// Mozilla's IE simulation
// Copyright  1997-2001 Butz Yung. All rights reserved.
// Do NOT copy or modify any part of the script without permission.
// All comments and notice must be left as is.
// Homepage: http://www.animetheme.com

// inner and outer

HTMLElement.prototype.__defineSetter__("innerText",
function (str) {
	var d = this.ownerDocument;
	var r = d.createRange();
	r.selectNodeContents(this);
	r.deleteContents();
	this.appendChild(d.createTextNode(str));
}
)

HTMLElement.prototype.__defineGetter__("innerText",
function () {
	var r = this.ownerDocument.createRange();
	r.selectNodeContents(this);
	return r.toString();
}
)

HTMLElement.prototype.__defineSetter__("outerHTML",
function (str) {
	var r = this.ownerDocument.createRange();
	r.setStartBefore(this);
	var df = r.createContextualFragment(str);
	this.parentNode.replaceChild(df, this);
}
)

HTMLElement.prototype.__defineGetter__("outerHTML",
function () {
	return getOuterHTML(this)
}
)

function getInnerHTML(node) {
	var str = "";
	for (var i=0; i<node.childNodes.length; i++)
		str += getOuterHTML(node.childNodes.item(i));
	return str;
}

function getOuterHTML(node) {
	var str = "";
	
	switch (node.nodeType) {
		case 1: // ELEMENT_NODE
			str += "<" + node.nodeName;
			for (var i=0; i<node.attributes.length; i++) {
				if (node.attributes.item(i).nodeValue != null) {
					str += " "
					str += node.attributes.item(i).nodeName;
					str += "=\"";
					str += node.attributes.item(i).nodeValue;
					str += "\"";
				}
			}

			if (node.childNodes.length == 0 && leafElems[node.nodeName])
				str += ">";
			else {
				str += ">";
				str += getInnerHTML(node);
				str += "<" + node.nodeName + ">"
			}
			break;
				
		case 3:	//TEXT_NODE
			str += node.nodeValue;
			break;
			
		case 4: // CDATA_SECTION_NODE
			str += "<![CDATA[" + node.nodeValue + "]]>";
			break;
					
		case 5: // ENTITY_REFERENCE_NODE
			str += "&" + node.nodeName + ";"
			break;

		case 8: // COMMENT_NODE
			str += "<!--" + node.nodeValue + "-->"
			break;
	}

	return str;
}

var _leafElems = ["IMG", "HR", "BR", "INPUT"];
var leafElems = {};
for (var i=0; i<_leafElems.length; i++)
	leafElems[_leafElems[i]] = true;

// End

// Other simulations

var all_id = 0
var ie_dom_initialized

document.__defineGetter__("all",
function () {
  var all = document.getElementsByTagName("*")
  initAll(all)
  return all
}
)

function initAll(all) {
  for (var i = all_id; i < all.length; i++)
    initElement(all[i])
  all_id = all.length
}

function initElement(e) {
  if (!e.id || e.initialized || e.id == "Seq")
    return

  if (e.tagName == "IFRAME") {
    var f = document.getElementsByTagName("IFRAME")
    for (var i = 0; i < f.length; i++) {
      if (f[i] == e) {
        self[e.id] = window.frames[i]
        break
      }
    }
  }
  else
    self[e.id] = e

  e.initialized = true
  if (ie_dom_initialized)
    return

  var p = document.body
  p.__defineGetter__("scrollLeft", function () { return window.scrollX })
  p.__defineGetter__("scrollTop", function () { return window.scrollY })
  p.__defineGetter__("clientWidth", function () { return window.innerWidth })
  p.__defineGetter__("clientHeight", function () { return window.innerHeight })

  p = p.style.constructor.prototype

//alert(self.CSS2Properties)

p.__defineGetter__("posLeft",
function () {
  var num = parseInt(this.left)
  if (!num)
    num = 0
  return num
}
)

p.__defineSetter__("posLeft",
function (num) {
  this.left = num + "px"
}
)

p.__defineGetter__("posTop",
function () {
  var num = parseInt(this.top)
  if (!num)
    num = 0
  return num
}
)

p.__defineSetter__("posTop",
function (num) {
  this.top = num + "px"
}
)

p.__defineGetter__("pixelWidth",
function () {
  var num = parseInt(this.width)
  if (!num)
    num = 0
  return num
}
)

p.__defineSetter__("pixelWidth",
function (num) {
  this.width = num + "px"
}
)

p.__defineGetter__("pixelHeight",
function () {
  var num = parseInt(this.height)
  if (!num)
    num = 0
  return num
}
)

p.__defineSetter__("pixelHeight",
function (num) {
  this.height = num + "px"
}
)

  ie_dom_initialized = true
}

function execScript(str) {
  eval(str)
}
